/* 
    qasn1editor - SignalWrapper - class for wrapping signals emitted by model/view
    Copyright(C) 2010 - Andrius da Costa Ribas

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef signalwrapper_h
#define signalwrapper_h
#include <QtGui>
#include "Asn1BerModel.h"

class SignalWrapper : public QObject
{
    Q_OBJECT
private:
    QLineEdit* m_tag;
    QCheckBox* m_constructed;
    QCheckBox* m_definedLength;
    QPlainTextEdit* m_rawValue;
    QRadioButton* m_universal;
    QRadioButton* m_application;
    QRadioButton* m_context;
    QRadioButton* m_private;
    
    Asn1BerModel* m_model;
    
    bool m_setUp;
public:
    SignalWrapper(QObject* parent);
    
    void setModel(Asn1BerModel* model);
    
    void setTagControl(QLineEdit* tag);
    void setConstructedControl(QCheckBox* constructed);
    void setDefinedLengthControl(QCheckBox* definedLength);
    void setRawValueControl(QPlainTextEdit* rawValue);
    void setRadioControls(QRadioButton* _universal, QRadioButton* _application, QRadioButton* _context, QRadioButton* _private);
    
    bool setupControls();
    
signals:
    void changeTag(QString );
    void changeConstructed(bool );
    void changeDefinedLength(bool );
    void changeRawValue(QString );
    void changeClassUniversal(bool );
    void changeClassApplication(bool );
    void changeClassContext(bool );
    void changeClassPrivate(bool );
    
public slots:
    void changeTree(QModelIndex index);
};

#endif