/* 
    qasn1 - qasn1_export - common macro definitions for build system for qasn1 library
    Copyright(C) 2010 - Andrius da Costa Ribas

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _QASN1_EXPORT_H_
#define _QASN1_EXPORT_H_

#ifdef _WIN32
/* qasn1_EXPORTS is set by cmake when building the shared 
 * library qasn1. This is used to find out whether to import
 * or export classes & functions
 */
# ifdef qasn1_EXPORTS // the library is build
#  define QASN1_EXPORT __declspec(dllexport)
# else // the library is used
#  define QASN1_EXPORT __declspec(dllimport)
# endif
#else // _WIN32
// for now lets not use any hiding under Linux
# define QASN1_EXPORT 
#endif // _WIN32
#endif
